#include <stdio.h>
#include <string.h>

void aponta (char string [][200], char *ptr[], int quantidade);
void ordena (char string[][200], char *ptr[], int quantidade);
void imprimeOrdem (char *ptr[], int quantidade);

int main()
{
    int i, quantidade;
    char string[200][200], *ptr[200];
    do //digita a quantidade de strings at que seja um valor vlido
    {
        printf ("Digite o numero de strings desejadas: ");
        scanf ("%d", &quantidade);
    }
    while (quantidade <= 0 || quantidade > 200);
    for (i = 0; i < quantidade; i++) //pega as strings
    {
        printf ("\nDigite a string %d: ", i+1);
        fflush(stdin);
        gets (string[i]);
    }

    aponta (string, ptr, quantidade); //chama a funo que aponta cada posio do vetor de ponteiro para uma linha do vetor de strings
    ordena (string, ptr, quantidade); //chama a funo que ordena para onde os ponteiros esto apontando
    imprimeOrdem (ptr, quantidade); //chama a funo que imprime as strings em ordem

    return 0;
}

void aponta (char string [][200], char *ptr[], int quantidade) //funo que faz cada posio do vetor de ponteiro apontar para uma linha do vetor de strings
{
    int i;
    for (i = 0; i < quantidade; i++)
    {
        ptr[i] = string[i];
    }
}


void ordena (char string[][200], char *ptr[], int quantidade) //funo que ordena os ponteiros
{
    int i, j;
    char *aux;

    for (i = 0; i < quantidade; i++)
    {
        for (j = 0; j < quantidade; j++)
        {
            if (strcmp (ptr[j], ptr[i]) > 0) //se o conteudo de uma linha for posterior da outra, troca o lugar que a posio do vetor de ponteiro aponta
            {
                aux = ptr[i];
                ptr[i] = ptr[j];
                ptr[j] = aux;
            }
        }
    }
}

void imprimeOrdem (char *ptr[], int quantidade) //funo que imprime as strings em ordem
{
    int i;
    printf ("\nStrings ordenadas:\n");
    for (i = 0; i < quantidade; i++) //imprime as strings que os ponteiros esto apontando em ordem
    {
        puts(ptr[i]);
    }
}
